<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BizAction.GiftVoucher.CouponsBatchOperation.PreviewItem
 * StructType
 * @subpackage Structs
 */
class BizAction_GiftVoucher_CouponsBatchOperation_PreviewItem extends AnyEntity
{
    /**
     * The CouponId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CouponId;
    /**
     * Constructor method for BizAction.GiftVoucher.CouponsBatchOperation.PreviewItem
     * @uses BizAction_GiftVoucher_CouponsBatchOperation_PreviewItem::setCouponId()
     * @param string $couponId
     */
    public function __construct($couponId = null)
    {
        $this
            ->setCouponId($couponId);
    }
    /**
     * Get CouponId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCouponId()
    {
        return isset($this->CouponId) ? $this->CouponId : null;
    }
    /**
     * Set CouponId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $couponId
     * @return \patest\StructType\BizAction_GiftVoucher_CouponsBatchOperation_PreviewItem
     */
    public function setCouponId($couponId = null)
    {
        // validation for constraint: string
        if (!is_null($couponId) && !is_string($couponId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($couponId, true), gettype($couponId)), __LINE__);
        }
        if (is_null($couponId) || (is_array($couponId) && empty($couponId))) {
            unset($this->CouponId);
        } else {
            $this->CouponId = $couponId;
        }
        return $this;
    }
}
